    SUBROUTINE NINE(N,H,TOL,ALPHA1,ALPHA2,BETA1,BETA2,GAMMA1,GAMMA2,KEY_TAU,TAUMIN,ITER_MAX,X,&
                    YNEWTON,V,Fk,Gk,Uk,AV,BV,DY,D2Y,Y)          
    IMPLICIT REAL*8 (A-H,O-Z)
    LOGICAL ERROR
    PARAMETER DELTA_MAX=10D0**10
	DIMENSION X(N),Y(N),YNEWTON(N),V(N),Fk(N),Gk(N),Uk(N),AV(N),BV(N),DY(N),D2Y(N)

    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    !!!                                                                              !!!
    !!!                      B.BATGEREL, E.V.ZEMLYANAYA, I.V.PUZYNIN                 !!! 
    !!!                                                                              !!!
    !!!      PRGORAMMA NINE FOR NUMERICAL SOLUTION OF THE BOUNDARY PROBLEMS FOR      !!!
    !!!            NONLINEAR DIFFERENTIAL EQUATIONS ON THE BASIS OF CANM             !!!
    !!!                                                                              !!!
    !!!                                 y" + f(x,y,y') = 0,                          !!! 
    !!!                                                                              !!!
    !!!                           alpha1*y'(a)+beta1*y(a) = gamma1,                  !!!
    !!!                                                                              !!!
    !!!                           alpha2*y'(b)+beta2*y(b) = gamma2.                  !!!
    !!!                                                                              !!!
    !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    
!    write(*,*) KEY_TAU
    IF (KEY_TAU==3 .OR. KEY_TAU==5 ) THEN
       KEY_NORM=2
    ELSE
       KEY_NORM=1
    END IF
    ITER=0	 
	DNORM2=DNORM(N,H,Y,2)	

    CALL LINSYS(N,H,ALPHA1,ALPHA2,BETA1,BETA2,GAMMA1,GAMMA2,X,Y,Fk,Gk,Uk,d1,d2,f1,f2,g1,g2,DY,D2Y)
	DELTA=DNORM(N,H,Uk,KEY_NORM)
		  
	CALL PROGON4(N,H,Fk,Gk,Uk,f1,f2,d1,d2,g1,g2,V,Av,bv)
	DO I=1,N
	   YNEWTON(I)=Y(I)+V(I)         
	ENDDO
    CALL LINSYS(N,H,ALPHA1,ALPHA2,BETA1,BETA2,GAMMA1,GAMMA2,X,YNEWTON, &
                Fk,Gk,Uk,d1,d2,f1,f2,g1,g2,DY,D2Y)
    DELTA11=DNORM(N,H,Uk,KEY_NORM)
	  
	CALL TAUZERO(KEY_TAU,DELTA,DELTA11,TAUMIN,TAU)	
	
    OPEN (9999,FILE='ITERATIONS')
	WRITE(9999,100) 'ITER    ','DELTA    ','TAU     ','NORM     ','DELTA11  '
	WRITE(9999,*)
	WRITE(9999,110)  ITER, DELTA, TAU, DNORM2, DELTA11
   
	DO WHILE(DELTA > TOL .AND. DELTA < DELTA_MAX .AND. ITER < ITER_MAX)
	   ITER=ITER+1
	   DO I=1,N
	      Y(I)=Y(I)+TAU*V(I)
       ENDDO
       DNORM2=DNORM(N,H,Y,2)
	   CALL LINSYS(N,H,ALPHA1,ALPHA2,BETA1,BETA2,GAMMA1,GAMMA2,X,Y,Fk,Gk,Uk,d1,d2,f1,f2,g1,g2,DY,D2Y)
	   CALL PROGON4(N,H,Fk,Gk,Uk,f1,f2,d1,d2,g1,g2,V,Av,bv)
       DELTA_OLD=DELTA
       IF (KEY_TAU==5) THEN
          DELTA=DNORM(N,H,Uk,2)
          DO I=1,N
	         YNEWTON(I)=Y(I)+V(I)         
	      ENDDO
          CALL LINSYS(N,H,ALPHA1,ALPHA2,BETA1,BETA2,GAMMA1,GAMMA2,X,YNEWTON, &
                      Fk,Gk,Uk,d1,d2,f1,f2,g1,g2,DY,D2Y)
          DELTA11=DNORM(N,H,Uk,2)
       ELSE
          DELTA=DNORM(N,H,Uk,1)
       ENDIF
	   CALL TAUKA(KEY_TAU,DELTA,DELTA_OLD,DELTA11,TAUMIN,TAU)
       IF (KEY_TAU==5) THEN
          WRITE(9999,110) ITER, DELTA, TAU, DNORM2, DELTA11
       ELSE
          WRITE(9999,110) ITER, DELTA, TAU, DNORM2
       ENDIF
    END DO
    CLOSE(9999)
    ERROR=.FALSE.
    IF (ITER >=ITER_MAX) THEN 
       WRITE(*,*) 'Error: Too many iterations'
       WRITE(*,*)
       ERROR=.TRUE.
    ENDIF
    IF (DELTA >= DELTA_MAX) THEN 
       WRITE(*,*) 'Error: Iteration dose not converge'
       WRITE(*,*)
       ERROR=.TRUE.
    ENDIF
    
    IF (ERROR == .FALSE.) THEN
       WRITE(*,*) 'Calculation has succesfully finished'
       WRITE(*,*)
       OPEN(9998,FILE='SOLUTION')
       DO I=1,N
          WRITE(9998,*) X(I),Y(I)
       ENDDO
       CLOSE(9998)
    ENDIF

100 FORMAT (2X, A4,   2X,   A16,   2X,   A16,   2X,  A16,   2X,  A16)
110 FORMAT (2X, I4,   2X,   E16.9, 2X,   E16.9, 2X,  E16.9, 2X,  E16.9)

	RETURN
    END
       
	SUBROUTINE LINSYS(N,H,ALPHA1,ALPHA2,BETA1,BETA2,GAMMA1,GAMMA2,X,Y,&
                      Fk,Gk,Uk,d1,d2,f1,f2,g1,g2,DY,D2Y)
	IMPLICIT REAL*8 (A-H,O-Z)
    DIMENSION X(N),Y(N),DY(N),D2Y(N),Fk(N),Gk(N),Uk(N)
    
    H2=H**2

    DY(1)=  (-25D0*Y(1)+48D0*Y(2)  -36D0*Y(3)  +16D0*Y(4)  -3D0*Y(5)   )/(12D0*H)
    DY(N)=  ( 25D0*Y(N)-48D0*Y(N-1)+36D0*Y(N-2)-16D0*Y(N-3)+3D0*Y(N-4) )/(12D0*H)
    DY(2)=  ( -3D0*Y(1)-10D0*Y(2)  +18D0*Y(3)   -6D0*Y(4)       +Y(5)  )/(12D0*H)
    DY(N-1)=(  3D0*Y(N)+10D0*Y(N-1)-18D0*Y(N-2) +6D0*Y(N-3)     -Y(N-4))/(12D0*H)

	D2Y(2)=  (10D0*Y(1)-15D0*Y(2)  -4D0*Y(3)  +14D0*Y(4)  -6D0*Y(5)  +Y(6)  )/(12D0*H2)
    D2Y(N-1)=(10D0*Y(N)-15D0*Y(N-1)-4D0*Y(N-2)+14D0*Y(N-3)-6D0*Y(N-4)+Y(N-5))/(12D0*H2)

	DO I=3,N-2
       DY(I)= ( Y(I-2)-8D0*Y(I-1)+8D0*Y(I+1)-Y(I+2))/(12D0*H)
	   D2Y(I)=(-Y(I-2)+16D0*Y(I-1)-30D0*Y(I)+16D0*Y(I+1)-Y(I+2))/(12D0*H2)
	ENDDO

	DO I=2,N-1
	   Fk(I)=FDY(X(I),Y(I),DY(I))
       Gk(I)=FY(X(I),Y(I),DY(I))
       Uk(I)=-D2Y(I)-FF(X(I),Y(I),DY(I))
    ENDDO
	
	d1=ALPHA1;                             d2=ALPHA2
    f1=BETA1;                              f2=BETA2
	g1=-ALPHA1*DY(1)-BETA1*Y(1)+GAMMA1;	   g2=-ALPHA2*DY(N)-BETA2*Y(N)+GAMMA2
	Uk(1)=g1;   	                       Uk(N)=g2
	
    RETURN
	END
    
    REAL*8 FUNCTION DNORM(N,H,Y,KEY_NORM)
    IMPLICIT REAL*8 (A-H,O-Z)
    DIMENSION Y(N)
		IF (KEY_NORM==1) THEN
			DMAX=DABS(Y(1))
			DO I=2,N
			   IF (DMAX < DABS(Y(I))) DMAX=DABS(Y(I))
            ENDDO
			DNORM=DMAX
		ELSE
			SUM=0D0
			DO I=1,N-2,2
			   SUM=SUM+Y(I)**2+4D0*Y(I+1)**2+Y(I+2)**2
            ENDDO
			DNORM=SUM*H/3D0
		END IF
	RETURN
	END

	SUBROUTINE TAUZERO(KEY_TAU,DELTA,DELTA11,TAUMIN,TAU)
	IMPLICIT REAL*8 (A-H,O-Z)
		IF (KEY_TAU==1)  THEN                              
		   TAU=0.5D0*DELTA/DELTA11
		ELSEIF (KEY_TAU==2)  THEN 
		   TAU=0.5D0*DABS(1D0-DELTA11/DELTA)
		ELSEIF (KEY_TAU==3 .OR. KEY_TAU==5)  THEN
           TAU=DELTA/(DELTA+DELTA11)
        ELSE
           TAU=TAUMIN
		ENDIF
        IF (TAU > 1D0)    TAU=1D0
		IF (TAU < TAUMIN) TAU=TAUMIN        
	RETURN
	END

	SUBROUTINE TAUKA (KEY_TAU,DELTA,DELTA_OLD,DELTA11,TAUMIN,TAU)
	IMPLICIT REAL*8 (A-H,O-Z)
        IF (KEY_TAU==5) THEN 
           TAU=DELTA/(DELTA+DELTA11)
        ELSE 
		   IF (DELTA < DELTA_OLD) THEN 
		      TAU=TAU*DELTA_OLD/DELTA 
		   ELSE 
		      TAU=TAU*DELTA_OLD/DELTA
		   END IF
        ENDIF
        IF (TAU > 1D0)    TAU=1D0
		IF (TAU < TAUMIN) TAU=TAUMIN
	RETURN
	END